# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import os
import shutil
from gui_util import dlg_get_text
import threading
import gobject
import multiprocessing
import time
import glob
from help import my_help_class

class progress_class(gtk.Window):

	def init(self):
		self.set_decorated(False)
		self.set_title("opvdm progress")
		self.set_size_request(400, 50)
		self.set_position(gtk.WIN_POS_CENTER)
		self.set_keep_above(True)

		main_hbox = gtk.HBox(False, 5)
		main_hbox.set_border_width(1)
		main_hbox.show()

		self.progress = gtk.ProgressBar(adjustment=None)
		self.progress.show()

		main_hbox.pack_start(self.progress, True, True, 0)

		self.spin=gtk.Spinner()
		self.spin.set_size_request(32, 32)
		self.spin.show()
		self.spin.stop()

		main_hbox.pack_start(self.spin, False, False, 0)


		main_vbox = gtk.VBox(False, 5)
		main_vbox.show()
		main_vbox.pack_start(main_hbox, True, True, 0)

		self.progress_array = []
		for i in range(0,10):
			self.progress_array.append(gtk.ProgressBar(adjustment=None))
			self.progress_array[i].hide()
			self.progress_array[i].set_size_request(-1, 15)
			self.progress_array[i].modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("green"))
			main_vbox.pack_end(self.progress_array[i], True, False, 0)

		self.label=gtk.Label("Running...")
		#label.set_justify(gtk.JUSTIFY_LEFT)
		self.label.show()

		main_vbox.pack_start(main_hbox, True, True, 0)
		main_vbox.pack_start(self.label, True, True, 4)


		self.add(main_vbox)

	def set_fraction(self,fraction):
		self.progress.set_fraction(fraction)

	def pulse(self):
		self.progress.pulse()

	def start(self):
		my_help_class.hide()

		s=gtk.gdk.screen_get_default()
		w,h=self.get_size()

		x=s.get_width()-w
		y=0

		self.move(x,y)

		self.show()
		self.spin.start()

	def stop(self):
		self.hide()
		self.spin.stop()
		my_help_class.help_show()

	def set_text(self,text):
		text=text
		l=len(text)
		if l>50:
			l=l-50
			text=text[l:]

		self.label.set_text(text)

