# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import math
import gobject
from inp import inp_update_token_value
from inp import inp_get_token_value

class tb_item_sun(gtk.ToolItem):
	def call_back_light_changed(self, widget, data=None):
		light_power=self.light.get_active_text()
		print light_power
		inp_update_token_value("light.inp", "#Psun", light_power,1)
		self.emit("refresh")

	def __init__(self):
		self.__gobject_init__()
		self.light = gtk.combo_box_entry_new_text()
		#self.sim_mode.set_size_request(-1, 20)
		sun_values=["0.0","0.01","0.1","1.0","10"]
		token=inp_get_token_value("light.inp", "#Psun")
		if sun_values.count(token)==0:
			sun_values.append(token)

		for i in range(0,len(sun_values)):
			self.light.append_text(sun_values[i])

		liststore = self.light.get_model()
		for i in xrange(len(liststore)):
		    if liststore[i][0] == token:
		        self.light.set_active(i)

		self.light.child.connect('changed', self.call_back_light_changed)

		lable=gtk.Label("Light intensity (Suns):")
		lable.show
		hbox = gtk.HBox(False, 2)
		hbox.pack_start(lable, False, False, 0)
		hbox.pack_start(self.light, False, False, 0)

		self.add(hbox)
		self.show_all()

gobject.type_register(tb_item_sun)
gobject.signal_new("refresh", tb_item_sun, gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE, ())

