# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import os
import time
import re
import gobject
import win32pipe
import win32file
import winerror
from threading import Thread
import threading


class win_pipe(gobject.GObject):
	def __init__(self):
		self.__gobject_init__()

	def foo(self,n):
		p = win32pipe.CreateNamedPipe(r'\\.\pipe\opvdm_pipe',
			win32pipe.PIPE_ACCESS_INBOUND,
			win32pipe.PIPE_TYPE_MESSAGE | win32pipe.PIPE_WAIT,
			1, 65536, 65536,300,None)

		while(1):
			#print "going to read"
			win32pipe.ConnectNamedPipe(p, None)
			res,data = win32file.ReadFile(p, 4096)
			#print res,data
			if res != winerror.ERROR_MORE_DATA:
				#print data
				#print "emit event from",threading.current_thread()
				#gobject.idle_add(gobject.GObject.emit,self,*args)
				#self.emit("new-data",data)
				gobject.idle_add(gobject.GObject.emit,self,"new-data",data)
			else:
				print "no more data"
			win32pipe.DisconnectNamedPipe(p)

	def start(self):
		p = Thread(target=self.foo, args=(10,))
		p.daemon = True
		p.start()


gobject.type_register(win_pipe)
gobject.signal_new("new-data", win_pipe, gobject.SIGNAL_RUN_FIRST,gobject.TYPE_NONE, (gobject.TYPE_STRING,))

